Manage Payees POC project
-------------------------

Use Case # : Tech stack - (Java8 + Spring boot + Microservice (REST API) +  Spring Kafka + MongoRepository + MongoDB)

 

Story :- Manage Payees -  As a Bank IT admin, Privileges' to search/add/update/delete payee details.

 

Requirement :-

 

1.) Search Payee Details
2.) Add Payee Details
3.) Update Payee Details
4.) Delete Payee Details

 

Manage Payees Implementation Add Payee, Search Payee, Update Payee and Delete Payee. 
The Payee's data should get persist and Payee's information to be retrieved into/from MongoDB collection.
Updated Payees information to be published into kafka message bus,
so that different consumers can consume the latest updates of payee in real time processing and also persist the latest updates of payee in a separate MongoDB collection for audit report.


Algorithm (Implementation steps)

 

1.) Implement different REST API(s) to search/add/update/delete payees that gets retrieved / persisted into MongoDB collection - named (manage_payees_info).
2.) Account number of payee to be autogenerated.
3.) Validate Account number and Daily Transaction Limit that should contain only digits.
4.) Implement Mappers for conversions from DTO to Entity / Entity to DTO.
5.) If anything update happens to payee information then updated record info will be published into kafka messsage bus.
6.) From kafka updated record info will get persisted into MongoDB collection - named (updated_payees_info).
7.) Kafka Producer/Consumer will be implemented to complete the steps #5 and #6.
8.) Handle Exceptions / Errors
9.) Proper json Response to the user.
10.) Layers  - Controller, Service, Repository. 
11.) Package structure - 
controller, service, repository, entity, dto, request, response, exception, mapper,constants, util, validation, kafka, config, resources..etc

 

Payee Details


Account number
Account name
Address
Reg. MobileNumber
Nick name
Branch code
Branch name
Nationality
Daily Transaction Limit

 

Collection details:-


1.) Collection name: "manage_payees_info"  


   For Eg:-
     [accountNumber : 010001000754, accountName : Naveen, address : Hyderabad, regMobileNumber : 91900000000, nickName:TN, branchCode:SBI0025, branchName:Phoenix, nationality: Indian, dailyLimit: 1000000]

2.) Collection name: "updated_payees_info"

 

For Eg:-
     [accountNumber : 010001000754, accountName : Naveen, branchCode:SBI0025, branchName:Phoenix, status: Updated, updatedDate: ]