package com.bank.it.payees.dto.mapper;

import com.bank.it.payees.dto.request.PayeeRequest;
import com.bank.it.payees.dto.response.PayeeResponse;
import com.bank.it.payees.entity.PayeeEntity;
import com.bank.it.payees.entity.PayeeUpdateEntity;
import com.bank.it.payees.model.Payee;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

import java.util.List;

@Mapper
public interface PayeeMapper {

    PayeeMapper MAPPER = Mappers.getMapper(PayeeMapper.class);

    PayeeEntity fromRequestToEntity(PayeeRequest payeeRequest);
    PayeeResponse fromEntityToResponse(PayeeEntity payeeEntity);
    Payee fromEntityToPayee(PayeeEntity payeeEntity);
    PayeeUpdateEntity fromPayeeToPayeeUpdateEntity(Payee payee);

    List<PayeeResponse> fromEntityListToResponseList(List<PayeeEntity> payeeEntity);
}
