package com.bank.it.payees.dto.request;

import com.bank.it.payees.constants.APIMessagesConstants;
import lombok.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.annotation.Id;

import javax.validation.constraints.*;
import java.io.Serializable;

@AllArgsConstructor
@NoArgsConstructor
@Data

public class PayeeRequest  implements Serializable{

    @Autowired
    private APIMessagesConstants errorMessagesConstants;

    @Id
    private String id;
    private int accountNumber;
    @NotNull(message = "Please provide valid account holder name")
    private String accountName;
    private String address;

    @Digits(message="Number should contain 10 digits.", fraction = 0, integer = 10)
    private String mobileNumber;
    private String nickName;
    private String branchCode;
    private String branchName;
    @NotBlank
    private String nationality;

    @Min(50000)
    @Max(500000)
    private int dailyTxnLimit;

}
