package com.bank.it.payees.kafka.Consumer;

import com.bank.it.payees.constants.KafkaConstants;
import com.bank.it.payees.dto.mapper.PayeeMapper;
import com.bank.it.payees.entity.PayeeUpdateEntity;
import com.bank.it.payees.model.Payee;
import com.bank.it.payees.repository.IUpdatePayeeRepository;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.stereotype.Component;

@Component
@Slf4j
public class ConsumerService {

    @Autowired
    private IUpdatePayeeRepository updatePayeeRepo;

    /**
     * Consumer Implementation
     * @param payee
     */
    @KafkaListener(topics = KafkaConstants.TOPIC_NAME, groupId = KafkaConstants.PAYEE_GROUP_ID, containerFactory = "kafkaListenerContainerFactory")
    private void consume(Payee payee) {
       PayeeUpdateEntity payeeUpdateEntity = PayeeMapper.MAPPER.fromPayeeToPayeeUpdateEntity(payee);
       updatePayeeRepo.insert(payeeUpdateEntity);
       log.info("Payee Details updated successfully via message bus :"+payeeUpdateEntity);
    }


}
