package com.bank.it.payees.kafka.Producer;

import com.bank.it.payees.constants.KafkaConstants;
import com.bank.it.payees.model.Payee;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.kafka.support.SendResult;
import org.springframework.stereotype.Component;
import org.springframework.util.concurrent.ListenableFuture;
import org.springframework.util.concurrent.ListenableFutureCallback;

@Component
@Slf4j
public class Producer {

    @Autowired
    private KafkaTemplate<String, Payee> kafkaTemplate;


    public Producer(KafkaTemplate<String,Payee> kafkaTemplate) {
        this.kafkaTemplate = kafkaTemplate;
    }

    /**
     * Publish the object
     * @param payee
     */
    public void sendMessage(Payee payee) {
        ListenableFuture<SendResult<String,Payee>> feature =kafkaTemplate.send(KafkaConstants.TOPIC_NAME, payee);
        feature.addCallback(new ListenableFutureCallback<SendResult<String,Payee>>() {
            @Override
            public void onFailure(Throwable ex) {
                log.info("Error occured while sending",ex);
            }

            @Override
            public void onSuccess(SendResult<String,Payee> result) {
                log.info("Send message successfully"+result);
            }
        });

    }

}

